package exnihilocreatio.items;

import com.google.common.collect.Lists;
import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.ModItems;
import exnihilocreatio.entities.ProjectileStone;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.IHasModel;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.*;
import net.minecraft.world.World;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.List;

public class ItemPebble extends Item implements IHasModel {
    private static final List<String> names = Lists.newArrayList("stone", "granite", "diorite", "andesite");

    public ItemPebble() {
        func_77655_b("item_pebble");
        setRegistryName("item_pebble");
        func_77637_a(ExNihiloCreatio.tabExNihilo);
        func_77627_a(true);

        Data.ITEMS.add(this);
    }

    public static ItemStack getPebbleStack(String name) {
        return new ItemStack(ModItems.pebbles, 1, names.indexOf(name));
    }

    @Override
    @Nonnull
    public String func_77667_c(ItemStack stack) {
        return func_77658_a() + "." + names.get(stack.func_77952_i());
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_150895_a(@Nullable CreativeTabs tab, NonNullList<ItemStack> list) {
        if (this.func_194125_a(tab))
            for (int i = 0; i < names.size(); i++) {
                list.add(new ItemStack(this, 1, i));
            }
    }

    @Override
    @Nonnull
    public ActionResult<ItemStack> func_77659_a(World world, EntityPlayer player, @Nonnull EnumHand hand) {
        ItemStack stack = player.func_184586_b(hand);

        stack.func_190918_g(1);
        world.func_184148_a(player, player.field_70165_t, player.field_70163_u, player.field_70161_v, SoundEvents.field_187797_fA, SoundCategory.NEUTRAL, 0.5F, 0.4F / (field_77697_d.nextFloat() * 0.4F + 0.8F));

        if (!world.field_72995_K) {
            ItemStack thrown = stack.func_77946_l();
            thrown.func_190920_e(1);

            ProjectileStone projectile = new ProjectileStone(world, player);
            projectile.setStack(thrown);
            projectile.func_184538_a(player, player.field_70125_A, player.field_70177_z, 0.0F, 1.5F, 0.5F);
            world.func_72838_d(projectile);
        }

        return new ActionResult<>(EnumActionResult.SUCCESS, stack);
    }

    public String getPebbleType(ItemStack stack) {
        if (stack.func_77960_j() >= names.size() || stack.func_77960_j() < 0) {
            return names.get(0);
        } else {
            return names.get(stack.func_77960_j());
        }
    }


    @Override
    @SideOnly(Side.CLIENT)
    public void initModel(ModelRegistryEvent e) {
        List<ModelResourceLocation> locations = new ArrayList<>();
        for (String name : names) {
            locations.add(new ModelResourceLocation(getRegistryName(), "type=" + name));
        }

        ModelBakery.registerItemVariants(this, locations.toArray(new ModelResourceLocation[0]));
        ModelLoader.setCustomMeshDefinition(this, stack -> locations.get(stack.func_77960_j()));

    }
}
